#!/usr/bin/python


class APIService(object):
	instance = None

	@classmethod
	def _check_config(cls):
		'''
		Check that the configuration wasn't broken... This is not bullet proof
		'''
		pass

	@classmethod
	def getInstance(cls, auth_struct):
		'''
		By default return a new instance... One should override this method
		if they want to have a special behavior
		'''
		try:
			return cls.backendClass.get_instance(auth_struct)
		except AttributeError:
			if cls.instance is None:
				cls.instance = cls.backendClass()
		return cls.instance


class SessionBackend(object):

	@classmethod
	def get_instance(cls, auth_struct):
		return cls()

	@classmethod
	def remove_instance(cls, auth_struct):
		pass
