#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jul 30 2014 08:45:28
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

from transformer.lib import Optional
from unicorn_api.v5.sv0.sdrive.SdriveAccountInfo import SdriveAccountInfo
from unicorn_api.v5.sv0.sdrive import SdriveUserStatus
from unicorn_api.v5.sv0.sdrive.Invite import Invite
from unicorn_api.v5.sv0.sdrive.InviteStatus import InviteStatus

from transformer.lib import Ciphered, List, Dict, ListInfo, ResultSet

from transformer.client_transport import ClientTransport
from transformer.client_serializer import ClientSerializer


class SdriveManagement(object):


    def accept_invite(self, sdrive_id, accept, __client__=None):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['accept'] = accept
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/sdrive.Management.accept_invite"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def accept_invite_async(self, sdrive_id, accept, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['accept'] = accept
        url = "api/local/5.0/sdrive.Management.accept_invite"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def add_invite_entry(self, invite_id, sdrive_id, sdrive_email, user_id, is_final_sdrive_id, __client__=None):
        params = dict()
        params['invite_id'] = invite_id
        params['sdrive_id'] = sdrive_id
        params['sdrive_email'] = sdrive_email
        params['user_id'] = user_id
        params['is_final_sdrive_id'] = is_final_sdrive_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/sdrive.Management.add_invite_entry"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def add_invite_entry_async(self, invite_id, sdrive_id, sdrive_email, user_id, is_final_sdrive_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['invite_id'] = invite_id
        params['sdrive_id'] = sdrive_id
        params['sdrive_email'] = sdrive_email
        params['user_id'] = user_id
        params['is_final_sdrive_id'] = is_final_sdrive_id
        url = "api/local/5.0/sdrive.Management.add_invite_entry"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def associate_device(self, sdrive_user, sdrive_password, __client__=None):
        params = dict()
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.associate_device"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def associate_device_async(self, sdrive_user, sdrive_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        url = "api/external/5.0/sdrive.Management.associate_device"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def associate_local_account(self, sdrive_id, login, password, __client__=None):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['login'] = login
        params['password'] = password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/sdrive.Management.associate_local_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def associate_local_account_async(self, sdrive_id, login, password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['login'] = login
        params['password'] = password
        url = "api/local/5.0/sdrive.Management.associate_local_account"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def associate_sdrive_account(self, sdrive_id, final_sdrive_id, final_email, invite_id, __client__=None):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['final_sdrive_id'] = final_sdrive_id
        params['final_email'] = final_email
        params['invite_id'] = invite_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/sdrive.Management.associate_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def associate_sdrive_account_async(self, sdrive_id, final_sdrive_id, final_email, invite_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['final_sdrive_id'] = final_sdrive_id
        params['final_email'] = final_email
        params['invite_id'] = invite_id
        url = "api/local/5.0/sdrive.Management.associate_sdrive_account"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def confirm_sdrive_user(self, user_email, confirmation_code, __client__=None):
        params = dict()
        params['user_email'] = user_email
        params['confirmation_code'] = confirmation_code
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.confirm_sdrive_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def confirm_sdrive_user_async(self, user_email, confirmation_code, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['confirmation_code'] = confirmation_code
        url = "api/external/5.0/sdrive.Management.confirm_sdrive_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def create_sdrive_user(self, user_email, user_password, password_hint, secured, __client__=None):
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        params['password_hint'] = password_hint
        params['secured'] = secured
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.create_sdrive_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def create_sdrive_user_async(self, user_email, user_password, password_hint, secured, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        params['password_hint'] = password_hint
        params['secured'] = secured
        url = "api/external/5.0/sdrive.Management.create_sdrive_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def del_sdrive_invites(self, invite_ids, __client__=None):
        params = dict()
        params['invite_ids'] = invite_ids
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.del_sdrive_invites"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['deleted']

    def del_sdrive_invites_async(self, invite_ids, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['invite_ids'] = invite_ids
        url = "api/external/5.0/sdrive.Management.del_sdrive_invites"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def disassociate(self, user_id, __client__=None):
        params = dict()
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.disassociate"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def disassociate_async(self, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        url = "api/external/5.0/sdrive.Management.disassociate"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_invite_status(self, sdrive_id, __client__=None):
        params = dict()
        params['sdrive_id'] = sdrive_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/local/5.0/sdrive.Management.get_invite_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def get_invite_status_async(self, sdrive_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        url = "api/local/5.0/sdrive.Management.get_invite_status"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_my_sdrive_account(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.get_my_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['info']

    def get_my_sdrive_account_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sdrive.Management.get_my_sdrive_account"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_remote_access(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.get_remote_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['enabled']

    def get_remote_access_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sdrive.Management.get_remote_access"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_remote_status(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.get_remote_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def get_remote_status_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sdrive.Management.get_remote_status"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_sdrive_account(self, user_id, __client__=None):
        params = dict()
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.get_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['info']

    def get_sdrive_account_async(self, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        url = "api/external/5.0/sdrive.Management.get_sdrive_account"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def get_user_status(self, user_email, __client__=None):
        params = dict()
        params['user_email'] = user_email
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.get_user_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['status']

    def get_user_status_async(self, user_email, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        url = "api/external/5.0/sdrive.Management.get_user_status"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def invite(self, email, inviter_password, __client__=None):
        params = dict()
        params['email'] = email
        params['inviter_password'] = inviter_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.invite"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def invite_async(self, email, inviter_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['email'] = email
        params['inviter_password'] = inviter_password
        url = "api/external/5.0/sdrive.Management.invite"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def invite_user(self, email, user_id, inviter_password, __client__=None):
        params = dict()
        params['email'] = email
        params['user_id'] = user_id
        params['inviter_password'] = inviter_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.invite_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def invite_user_async(self, email, user_id, inviter_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['email'] = email
        params['user_id'] = user_id
        params['inviter_password'] = inviter_password
        url = "api/external/5.0/sdrive.Management.invite_user"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def is_registration_done(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.is_registration_done"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['done']

    def is_registration_done_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sdrive.Management.is_registration_done"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def list_sdrive_invites(self, with_parameters, list_info, __client__=None):
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.list_sdrive_invites"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['invites']

    def list_sdrive_invites_async(self, with_parameters, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        url = "api/external/5.0/sdrive.Management.list_sdrive_invites"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def registerDevice(self, __client__=None):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.registerDevice"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def registerDevice_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/5.0/sdrive.Management.registerDevice"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def set_remote_access(self, enabled, __client__=None):
        """
         enable or disable remote access
        """
        params = dict()
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.set_remote_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def set_remote_access_async(self, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enabled'] = enabled
        url = "api/external/5.0/sdrive.Management.set_remote_access"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def update_credentials(self, old_password, new_password, __client__=None):
        params = dict()
        params['old_password'] = old_password
        params['new_password'] = new_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.update_credentials"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return 

    def update_credentials_async(self, old_password, new_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['old_password'] = old_password
        params['new_password'] = new_password
        url = "api/external/5.0/sdrive.Management.update_credentials"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')


    def user_valid(self, user_email, user_password, __client__=None):
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport

        url = "api/external/5.0/sdrive.Management.user_valid"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string('unicorn_api', params))
        res = ClientSerializer.from_string('unicorn_api', success, resp)
        return res['is_valid']

    def user_valid_async(self, user_email, user_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        url = "api/external/5.0/sdrive.Management.user_valid"
        ClientTransportSender.async(url,ClientSerializer.to_string('unicorn_api', params), callback, 'unicorn_api')
