#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject


class AuthBackupConfigInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'auth_domain': Optional(unicode),
        'auth_login': Optional(unicode),
        'auth_pass': Optional(unicode),
    }
    w_attributes = ["auth_domain", "auth_login", "auth_pass"]
    r_attributes = ["auth_domain", "auth_login", "auth_pass"]
    h_attributes = []
    op_values = {'auth_login': None, 'auth_pass': None, 'auth_domain': None}

    @classmethod
    def name(cls):
        return u'AuthBackupConfig'

    @classmethod
    def new_object(cls):
        return AuthBackupConfig()


class AuthBackupConfig(ClientObject):

    def setauth_domain(self, value):
        self.auth_domain = value

    def setauth_login(self, value):
        self.auth_login = value

    def setauth_pass(self, value):
        self.auth_pass = value

    def getauth_domain(self):
        return self.auth_domain

    def getauth_login(self):
        return self.auth_login

    def getauth_pass(self):
        return self.auth_pass
    __instantiator__ = AuthBackupConfigInstantiator
register_instantiator('unicorn_api', AuthBackupConfigInstantiator, True)
