#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.backup import BackupKind
from unicorn_api.v6.sv0.backup.BackupSpecific import BackupSpecific
from unicorn_api.v6.sv0.jobs import JobType
from unicorn_api.v6.sv0.jobs import JobStatus
from unicorn_api.v6.sv0.jobs.Scheduler import Scheduler

from transformer.lib import List, Long


class BackupInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'archived': bool,
        'auto': bool,
        'auto_eject': bool,
        'content_id': int,
        'dst_data_path': unicode,
        'dst_path': unicode,
        'enabled': bool,
        'error_code': int,
        'id': int,
        'kind': BackupKind,
        'name': unicode,
        'owner_id': int,
        'owner_login': unicode,
        'progress': Long,
        'scheduler': Optional(Scheduler),
        'size': Long,
        'specific': BackupSpecific,
        'src_path': List(unicode),
        'status': JobStatus,
        'type': JobType,
    }
    w_attributes = ["archived", "auto", "auto_eject", "content_id", "dst_data_path", "dst_path", "enabled", "id", "kind", "name", "owner_id", "owner_login", "scheduler", "specific", "src_path", "type"]
    r_attributes = ["archived", "auto", "auto_eject", "content_id", "dst_data_path", "dst_path", "enabled", "error_code", "id", "kind", "name", "owner_id", "owner_login", "progress", "scheduler", "size", "specific", "src_path", "status", "type"]
    h_attributes = []
    op_values = {'scheduler': None}

    @classmethod
    def name(cls):
        return u'Backup'

    @classmethod
    def new_object(cls):
        return Backup()


class Backup(ClientObject):

    def setarchived(self, value):
        self.archived = value

    def setauto(self, value):
        self.auto = value

    def setauto_eject(self, value):
        self.auto_eject = value

    def setcontent_id(self, value):
        self.content_id = value

    def setdst_data_path(self, value):
        self.dst_data_path = value

    def setdst_path(self, value):
        self.dst_path = value

    def setenabled(self, value):
        self.enabled = value

    def setid(self, value):
        self.id = value

    def setkind(self, value):
        self.kind = value

    def setname(self, value):
        self.name = value

    def setowner_id(self, value):
        self.owner_id = value

    def setowner_login(self, value):
        self.owner_login = value

    def setscheduler(self, value):
        self.scheduler = value

    def setspecific(self, value):
        self.specific = value

    def setsrc_path(self, value):
        self.src_path = value

    def settype(self, value):
        self.type = value

    def getarchived(self):
        return self.archived

    def getauto(self):
        return self.auto

    def getauto_eject(self):
        return self.auto_eject

    def getcontent_id(self):
        return self.content_id

    def getdst_data_path(self):
        return self.dst_data_path

    def getdst_path(self):
        return self.dst_path

    def getenabled(self):
        return self.enabled

    def geterror_code(self):
        return self.error_code

    def getid(self):
        return self.id

    def getkind(self):
        return self.kind

    def getname(self):
        return self.name

    def getowner_id(self):
        return self.owner_id

    def getowner_login(self):
        return self.owner_login

    def getprogress(self):
        return self.progress

    def getscheduler(self):
        return self.scheduler

    def getsize(self):
        return self.size

    def getspecific(self):
        return self.specific

    def getsrc_path(self):
        return self.src_path

    def getstatus(self):
        return self.status

    def gettype(self):
        return self.type
    __instantiator__ = BackupInstantiator
register_instantiator('unicorn_api', BackupInstantiator, True)
