#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v6.sv0.backup.AuthBackupConfig import AuthBackupConfig
from unicorn_api.v6.sv0.backup.BackupConfig import BackupConfig

from transformer.lib import List

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class BackupAdministration(APIService):


    def conflict_list(self, job_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['job_id'] = job_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.conflict_list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['conflicts']

    def conflict_list_async(self, job_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['job_id'] = job_id
        url = "api/external/6.0/backup.BackupAdministration.conflict_list"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def conflict_update(self, job_id, resolve, sources, destination, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['job_id'] = job_id
        params['resolve'] = resolve
        params['sources'] = sources
        params['destination'] = destination
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.conflict_update"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['success']

    def conflict_update_async(self, job_id, resolve, sources, destination, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['job_id'] = job_id
        params['resolve'] = resolve
        params['sources'] = sources
        params['destination'] = destination
        url = "api/external/6.0/backup.BackupAdministration.conflict_update"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def folder_list(self, dst_path, auth_login, auth_pass, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['dst_path'] = dst_path
        params['auth_login'] = auth_login
        params['auth_pass'] = auth_pass
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.folder_list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['folders']

    def folder_list_async(self, dst_path, auth_login, auth_pass, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['dst_path'] = dst_path
        params['auth_login'] = auth_login
        params['auth_pass'] = auth_pass
        url = "api/external/6.0/backup.BackupAdministration.folder_list"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def module_list(self, dst_path, auth_login, auth_pass, auth_domain, use_proxy, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['dst_path'] = dst_path
        params['auth_login'] = auth_login
        params['auth_pass'] = auth_pass
        params['auth_domain'] = auth_domain
        params['use_proxy'] = use_proxy
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.module_list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['shares']

    def module_list_async(self, dst_path, auth_login, auth_pass, auth_domain, use_proxy, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['dst_path'] = dst_path
        params['auth_login'] = auth_login
        params['auth_pass'] = auth_pass
        params['auth_domain'] = auth_domain
        params['use_proxy'] = use_proxy
        url = "api/external/6.0/backup.BackupAdministration.module_list"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_auth(self, job_id, authentification, __client__=None, timeout=None, raw_output=False):
        """
        Update auth properties for a given backup
        To get the id use the JobAdministration.list function
        """
        params = dict()
        params['job_id'] = job_id
        params['authentification'] = authentification
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.set_auth"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['success']

    def set_auth_async(self, job_id, authentification, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['job_id'] = job_id
        params['authentification'] = authentification
        url = "api/external/6.0/backup.BackupAdministration.set_auth"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_config(self, job_id, auth, config, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['job_id'] = job_id
        params['auth'] = auth
        params['config'] = config
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/backup.BackupAdministration.set_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['success']

    def set_config_async(self, job_id, auth, config, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['job_id'] = job_id
        params['auth'] = auth
        params['config'] = config
        url = "api/external/6.0/backup.BackupAdministration.set_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
