#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.backup import SyncConflict


class BackupConfigInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'option_compression': bool,
        'option_conflict': Optional(SyncConflict),
        'option_delete': bool,
        'option_differential_transfer': bool,
        'option_encryption': bool,
        'option_sync': bool,
        'use_proxy': bool,
    }
    w_attributes = ["option_compression", "option_conflict", "option_delete", "option_differential_transfer", "option_encryption", "option_sync", "use_proxy"]
    r_attributes = ["option_compression", "option_conflict", "option_delete", "option_differential_transfer", "option_encryption", "option_sync", "use_proxy"]
    h_attributes = []
    op_values = {'option_conflict': None}

    @classmethod
    def name(cls):
        return u'BackupConfig'

    @classmethod
    def new_object(cls):
        return BackupConfig()


class BackupConfig(ClientObject):

    def setoption_compression(self, value):
        self.option_compression = value

    def setoption_conflict(self, value):
        self.option_conflict = value

    def setoption_delete(self, value):
        self.option_delete = value

    def setoption_differential_transfer(self, value):
        self.option_differential_transfer = value

    def setoption_encryption(self, value):
        self.option_encryption = value

    def setoption_sync(self, value):
        self.option_sync = value

    def setuse_proxy(self, value):
        self.use_proxy = value

    def getoption_compression(self):
        return self.option_compression

    def getoption_conflict(self):
        return self.option_conflict

    def getoption_delete(self):
        return self.option_delete

    def getoption_differential_transfer(self):
        return self.option_differential_transfer

    def getoption_encryption(self):
        return self.option_encryption

    def getoption_sync(self):
        return self.option_sync

    def getuse_proxy(self):
        return self.use_proxy
    __instantiator__ = BackupConfigInstantiator
register_instantiator('unicorn_api', BackupConfigInstantiator, True)
