#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.backup import BackupKind

from transformer.lib import List, Date


class BackupFolderInfoInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'dest': unicode,
        'kind': BackupKind,
        'last_successful_date': Date,
        'last_successful_id': int,
        'name': unicode,
        'sources': List(unicode),
    }
    w_attributes = []
    r_attributes = ["dest", "kind", "last_successful_date", "last_successful_id", "name", "sources"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'BackupFolderInfo'

    @classmethod
    def new_object(cls):
        return BackupFolderInfo()


class BackupFolderInfo(ClientObject):

    def getdest(self):
        return self.dest

    def getkind(self):
        return self.kind

    def getlast_successful_date(self):
        return self.last_successful_date

    def getlast_successful_id(self):
        return self.last_successful_id

    def getname(self):
        return self.name

    def getsources(self):
        return self.sources
    __instantiator__ = BackupFolderInfoInstantiator
register_instantiator('unicorn_api', BackupFolderInfoInstantiator, True)
