#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.jobs import JobStatus

from transformer.lib import Date, Long


class BackupHistoryInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'end_date': Date,
        'error_code': int,
        'inc_size': Long,
        'job_id': int,
        'start_date': Date,
        'status': JobStatus,
        'total': Long,
        'unique_id': int,
        'valid': bool,
    }
    w_attributes = []
    r_attributes = ["end_date", "error_code", "inc_size", "job_id", "start_date", "status", "total", "unique_id", "valid"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'BackupHistory'

    @classmethod
    def new_object(cls):
        return BackupHistory()


class BackupHistory(ClientObject):

    def getend_date(self):
        return self.end_date

    def geterror_code(self):
        return self.error_code

    def getinc_size(self):
        return self.inc_size

    def getjob_id(self):
        return self.job_id

    def getstart_date(self):
        return self.start_date

    def getstatus(self):
        return self.status

    def gettotal(self):
        return self.total

    def getunique_id(self):
        return self.unique_id

    def getvalid(self):
        return self.valid
    __instantiator__ = BackupHistoryInstantiator
register_instantiator('unicorn_api', BackupHistoryInstantiator, True)
