#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.jobs import JobType
from unicorn_api.v6.sv0.jobs import JobStatus
from unicorn_api.v6.sv0.jobs.Scheduler import Scheduler

from transformer.lib import Date, Long


class RestoreInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'clear': bool,
        'content_id': int,
        'enabled': bool,
        'error_code': int,
        'id': int,
        'name': unicode,
        'no_check': bool,
        'owner_id': int,
        'owner_login': unicode,
        'progress': Long,
        'restore_date': Date,
        'restore_dst': Optional(unicode),
        'scheduler': Optional(Scheduler),
        'size': Long,
        'src_folder': unicode,
        'status': JobStatus,
        'type': JobType,
        'unique_id': int,
    }
    w_attributes = ["clear", "content_id", "enabled", "id", "name", "no_check", "owner_id", "owner_login", "restore_date", "restore_dst", "scheduler", "src_folder", "type", "unique_id"]
    r_attributes = ["clear", "content_id", "enabled", "error_code", "id", "name", "no_check", "owner_id", "owner_login", "progress", "restore_date", "restore_dst", "scheduler", "size", "src_folder", "status", "type", "unique_id"]
    h_attributes = []
    op_values = {'restore_dst': None, 'scheduler': None}

    @classmethod
    def name(cls):
        return u'Restore'

    @classmethod
    def new_object(cls):
        return Restore()


class Restore(ClientObject):

    def setclear(self, value):
        self.clear = value

    def setcontent_id(self, value):
        self.content_id = value

    def setenabled(self, value):
        self.enabled = value

    def setid(self, value):
        self.id = value

    def setname(self, value):
        self.name = value

    def setno_check(self, value):
        self.no_check = value

    def setowner_id(self, value):
        self.owner_id = value

    def setowner_login(self, value):
        self.owner_login = value

    def setrestore_date(self, value):
        self.restore_date = value

    def setrestore_dst(self, value):
        self.restore_dst = value

    def setscheduler(self, value):
        self.scheduler = value

    def setsrc_folder(self, value):
        self.src_folder = value

    def settype(self, value):
        self.type = value

    def setunique_id(self, value):
        self.unique_id = value

    def getclear(self):
        return self.clear

    def getcontent_id(self):
        return self.content_id

    def getenabled(self):
        return self.enabled

    def geterror_code(self):
        return self.error_code

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getno_check(self):
        return self.no_check

    def getowner_id(self):
        return self.owner_id

    def getowner_login(self):
        return self.owner_login

    def getprogress(self):
        return self.progress

    def getrestore_date(self):
        return self.restore_date

    def getrestore_dst(self):
        return self.restore_dst

    def getscheduler(self):
        return self.scheduler

    def getsize(self):
        return self.size

    def getsrc_folder(self):
        return self.src_folder

    def getstatus(self):
        return self.status

    def gettype(self):
        return self.type

    def getunique_id(self):
        return self.unique_id
    __instantiator__ = RestoreInstantiator
register_instantiator('unicorn_api', RestoreInstantiator, True)
