#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject


class DyndnsConfigInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'alias': Optional(unicode),
        'dyndns_system': Optional(unicode),
        'enable': Optional(bool),
        'ip_server_name': unicode,
        'password': Optional(unicode),
        'username': Optional(unicode),
    }
    w_attributes = ["alias", "dyndns_system", "enable", "password", "username"]
    r_attributes = ["alias", "dyndns_system", "enable", "ip_server_name", "password", "username"]
    h_attributes = []
    op_values = {'password': None, 'alias': None, 'enable': None, 'dyndns_system': None, 'username': None}

    @classmethod
    def name(cls):
        return u'DyndnsConfig'

    @classmethod
    def new_object(cls):
        return DyndnsConfig()


class DyndnsConfig(ClientObject):

    def setalias(self, value):
        self.alias = value

    def setdyndns_system(self, value):
        self.dyndns_system = value

    def setenable(self, value):
        self.enable = value

    def setpassword(self, value):
        self.password = value

    def setusername(self, value):
        self.username = value

    def getalias(self):
        return self.alias

    def getdyndns_system(self):
        return self.dyndns_system

    def getenable(self):
        return self.enable

    def getip_server_name(self):
        return self.ip_server_name

    def getpassword(self):
        return self.password

    def getusername(self):
        return self.username
    __instantiator__ = DyndnsConfigInstantiator
register_instantiator('unicorn_api', DyndnsConfigInstantiator, True)
