#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Ciphered


class UnlockVolumeParametersInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'password': Optional(Ciphered),
        'share_id': Optional(int),
        'volume_id': int,
        'wait_mounted': Optional(bool),
    }
    w_attributes = ["password", "share_id", "volume_id", "wait_mounted"]
    r_attributes = ["password", "share_id", "volume_id", "wait_mounted"]
    h_attributes = []
    op_values = {'wait_mounted': True, 'password': u"", 'share_id': 0}

    @classmethod
    def name(cls):
        return u'UnlockVolumeParameters'

    @classmethod
    def new_object(cls):
        return UnlockVolumeParameters()


class UnlockVolumeParameters(ClientObject):

    def setpassword(self, value):
        self.password = value

    def setshare_id(self, value):
        self.share_id = value

    def setvolume_id(self, value):
        self.volume_id = value

    def setwait_mounted(self, value):
        self.wait_mounted = value

    def getpassword(self):
        return self.password

    def getshare_id(self):
        return self.share_id

    def getvolume_id(self):
        return self.volume_id

    def getwait_mounted(self):
        return self.wait_mounted
    __instantiator__ = UnlockVolumeParametersInstantiator
register_instantiator('unicorn_api', UnlockVolumeParametersInstantiator, True)
