#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.filesharing import FileSharingType
from unicorn_api.v6.sv0.filesharing.WebLink import WebLink
from unicorn_api.v6.sv0.filesharing.SdriveLink import SdriveLink

from transformer.lib import Date


class FileLinkInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'description': Optional(unicode),
        'enabled': bool,
        'expired': bool,
        'expires': Optional(Date),
        'key': unicode,
        'name': Optional(unicode),
        'path': unicode,
        'sdrivelink': Optional(SdriveLink),
        'share_type': FileSharingType,
        'weblink': Optional(WebLink),
    }
    w_attributes = ["description", "expires", "name", "path", "sdrivelink", "share_type", "weblink"]
    r_attributes = ["description", "enabled", "expired", "expires", "key", "name", "path", "sdrivelink", "share_type", "weblink"]
    h_attributes = []
    op_values = {'sdrivelink': None, 'expires': None, 'description': None, 'weblink': None, 'name': None}

    @classmethod
    def name(cls):
        return u'FileLink'

    @classmethod
    def new_object(cls):
        return FileLink()


class FileLink(ClientObject):

    def setdescription(self, value):
        self.description = value

    def setexpires(self, value):
        self.expires = value

    def setname(self, value):
        self.name = value

    def setpath(self, value):
        self.path = value

    def setsdrivelink(self, value):
        self.sdrivelink = value

    def setshare_type(self, value):
        self.share_type = value

    def setweblink(self, value):
        self.weblink = value

    def getdescription(self):
        return self.description

    def getenabled(self):
        return self.enabled

    def getexpired(self):
        return self.expired

    def getexpires(self):
        return self.expires

    def getkey(self):
        return self.key

    def getname(self):
        return self.name

    def getpath(self):
        return self.path

    def getsdrivelink(self):
        return self.sdrivelink

    def getshare_type(self):
        return self.share_type

    def getweblink(self):
        return self.weblink
    __instantiator__ = FileLinkInstantiator
register_instantiator('unicorn_api', FileLinkInstantiator, True)
