#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v6.sv0.filesharing.FileLink import FileLink
from unicorn_api.v6.sv0.filesharing.Restricted import Restricted

from transformer.lib import ListInfo, ResultSet, List

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class FileSharing(APIService):


    def check_password(self, key, value, tokenvalue, __client__=None, timeout=None, raw_output=False):
        """
        Return the actual path to share
        """
        params = dict()
        params['key'] = key
        params['value'] = value
        params['tokenvalue'] = tokenvalue
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.check_password"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['result']

    def check_password_async(self, key, value, tokenvalue, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        params['value'] = value
        params['tokenvalue'] = tokenvalue
        url = "api/external/6.0/filesharing.FileSharing.check_password"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def create_share_link(self, share_link, message, send_confirmation, mails, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['share_link'] = share_link
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['mails'] = mails
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.create_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['link']

    def create_share_link_async(self, share_link, message, send_confirmation, mails, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_link'] = share_link
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['mails'] = mails
        url = "api/external/6.0/filesharing.FileSharing.create_share_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def delete_share_link(self, key, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['key'] = key
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.delete_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def delete_share_link_async(self, key, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        url = "api/external/6.0/filesharing.FileSharing.delete_share_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_share_link_from_key(self, key, __client__=None, timeout=None, raw_output=False):
        """
        Return the actual path to share
        """
        params = dict()
        params['key'] = key
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.get_share_link_from_key"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['link']

    def get_share_link_from_key_async(self, key, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        url = "api/external/6.0/filesharing.FileSharing.get_share_link_from_key"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def list_share_links(self, list_info, __client__=None, timeout=None, raw_output=False):
        """
        If user request, only sees it
        """
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.list_share_links"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['share_links']

    def list_share_links_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/6.0/filesharing.FileSharing.list_share_links"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def my_share_links(self, list_info, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.my_share_links"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['share_links']

    def my_share_links_async(self, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        url = "api/external/6.0/filesharing.FileSharing.my_share_links"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def my_share_links_from_path(self, list_info, path, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['list_info'] = list_info
        params['path'] = path
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.my_share_links_from_path"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['share_links']

    def my_share_links_from_path_async(self, list_info, path, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['list_info'] = list_info
        params['path'] = path
        url = "api/external/6.0/filesharing.FileSharing.my_share_links_from_path"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def sdrive_link_add_users(self, key, message, send_confirmation, users, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['key'] = key
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['users'] = users
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.sdrive_link_add_users"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['link']

    def sdrive_link_add_users_async(self, key, message, send_confirmation, users, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['users'] = users
        url = "api/external/6.0/filesharing.FileSharing.sdrive_link_add_users"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def sdrive_link_modify_users_rights(self, key, users, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['key'] = key
        params['users'] = users
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.sdrive_link_modify_users_rights"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['link']

    def sdrive_link_modify_users_rights_async(self, key, users, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        params['users'] = users
        url = "api/external/6.0/filesharing.FileSharing.sdrive_link_modify_users_rights"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_enabled_share_link(self, key, enabled, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['key'] = key
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.set_enabled_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['share_link']

    def set_enabled_share_link_async(self, key, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['key'] = key
        params['enabled'] = enabled
        url = "api/external/6.0/filesharing.FileSharing.set_enabled_share_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def update_share_link(self, share_link, key, message, send_confirmation, mails, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['share_link'] = share_link
        params['key'] = key
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['mails'] = mails
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/filesharing.FileSharing.update_share_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['link']

    def update_share_link_async(self, share_link, key, message, send_confirmation, mails, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['share_link'] = share_link
        params['key'] = key
        params['message'] = message
        params['send_confirmation'] = send_confirmation
        params['mails'] = mails
        url = "api/external/6.0/filesharing.FileSharing.update_share_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
