#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.iscsi_multi_lun import LunType
from unicorn_api.v6.sv0.iscsi_multi_lun import LunAllocation
from unicorn_api.v6.sv0.iscsi_multi_lun import LunStatus

from transformer.lib import Long, List


class LunInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'allocation': Optional(LunAllocation),
        'current_progress': int,
        'description': unicode,
        'enabled': bool,
        'id': Optional(int),
        'parted': Optional(bool),
        'pool_name': Optional(unicode),
        'real_usage': Optional(Long),
        'size': Optional(Long),
        'status': Optional(LunStatus),
        'target_ids': Optional(List(int)),
        'type': Optional(LunType),
        'volume_id': Optional(int),
    }
    w_attributes = ["allocation", "description", "id", "parted", "pool_name", "real_usage", "size", "status", "target_ids", "type", "volume_id"]
    r_attributes = ["allocation", "current_progress", "description", "enabled", "id", "pool_name", "real_usage", "size", "status", "target_ids", "type", "volume_id"]
    h_attributes = []
    op_values = {'status': None, 'pool_name': None, 'parted': None, 'real_usage': None, 'allocation': None, 'target_ids': None, 'volume_id': None, 'type': None, 'id': None, 'size': None}

    @classmethod
    def name(cls):
        return u'Lun'

    @classmethod
    def new_object(cls):
        return Lun()


class Lun(ClientObject):

    def setallocation(self, value):
        self.allocation = value

    def setdescription(self, value):
        self.description = value

    def setid(self, value):
        self.id = value

    def setparted(self, value):
        self.parted = value

    def setpool_name(self, value):
        self.pool_name = value

    def setreal_usage(self, value):
        self.real_usage = value

    def setsize(self, value):
        self.size = value

    def setstatus(self, value):
        self.status = value

    def settarget_ids(self, value):
        self.target_ids = value

    def settype(self, value):
        self.type = value

    def setvolume_id(self, value):
        self.volume_id = value

    def getallocation(self):
        return self.allocation

    def getcurrent_progress(self):
        return self.current_progress

    def getdescription(self):
        return self.description

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getpool_name(self):
        return self.pool_name

    def getreal_usage(self):
        return self.real_usage

    def getsize(self):
        return self.size

    def getstatus(self):
        return self.status

    def gettarget_ids(self):
        return self.target_ids

    def gettype(self):
        return self.type

    def getvolume_id(self):
        return self.volume_id
    __instantiator__ = LunInstantiator
register_instantiator('unicorn_api', LunInstantiator, True)
