#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.jobs import JobType
from unicorn_api.v6.sv0.jobs import JobStatus
from unicorn_api.v6.sv0.jobs.Scheduler import Scheduler

from transformer.lib import Long


class JobInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'content_id': int,
        'enabled': bool,
        'error_code': int,
        'id': int,
        'name': unicode,
        'owner_id': int,
        'owner_login': unicode,
        'progress': Long,
        'scheduler': Optional(Scheduler),
        'size': Long,
        'status': JobStatus,
        'type': JobType,
    }
    w_attributes = ["content_id", "enabled", "id", "name", "owner_id", "owner_login", "scheduler", "type"]
    r_attributes = ["content_id", "enabled", "error_code", "id", "name", "owner_id", "owner_login", "progress", "scheduler", "size", "status", "type"]
    h_attributes = []
    op_values = {'scheduler': None}

    @classmethod
    def name(cls):
        return u'Job'

    @classmethod
    def new_object(cls):
        return Job()


class Job(ClientObject):

    def setcontent_id(self, value):
        self.content_id = value

    def setenabled(self, value):
        self.enabled = value

    def setid(self, value):
        self.id = value

    def setname(self, value):
        self.name = value

    def setowner_id(self, value):
        self.owner_id = value

    def setowner_login(self, value):
        self.owner_login = value

    def setscheduler(self, value):
        self.scheduler = value

    def settype(self, value):
        self.type = value

    def getcontent_id(self):
        return self.content_id

    def getenabled(self):
        return self.enabled

    def geterror_code(self):
        return self.error_code

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getowner_id(self):
        return self.owner_id

    def getowner_login(self):
        return self.owner_login

    def getprogress(self):
        return self.progress

    def getscheduler(self):
        return self.scheduler

    def getsize(self):
        return self.size

    def getstatus(self):
        return self.status

    def gettype(self):
        return self.type
    __instantiator__ = JobInstantiator
register_instantiator('unicorn_api', JobInstantiator, True)
