#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.local_invites.LocalInviteRemoteConfig import LocalInviteRemoteConfig

from transformer.lib import Ciphered


class InviteCompletedInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'email': Optional(unicode),
        'local_login': unicode,
        'local_password': Ciphered,
        'remote_config': Optional(LocalInviteRemoteConfig),
    }
    w_attributes = ["email", "local_login", "local_password", "remote_config"]
    r_attributes = ["email", "local_login", "local_password", "remote_config"]
    h_attributes = []
    op_values = {'email': None, 'remote_config': None}

    @classmethod
    def name(cls):
        return u'InviteCompleted'

    @classmethod
    def new_object(cls):
        return InviteCompleted()


class InviteCompleted(ClientObject):

    def setemail(self, value):
        self.email = value

    def setlocal_login(self, value):
        self.local_login = value

    def setlocal_password(self, value):
        self.local_password = value

    def setremote_config(self, value):
        self.remote_config = value

    def getemail(self):
        return self.email

    def getlocal_login(self):
        return self.local_login

    def getlocal_password(self):
        return self.local_password

    def getremote_config(self):
        return self.remote_config
    __instantiator__ = InviteCompletedInstantiator
register_instantiator('unicorn_api', InviteCompletedInstantiator, True)
