#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Dict


class LocalInviteInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'additional_parameters': Dict(unicode),
        'create_share': Optional(bool),
        'email': unicode,
        'id': int,
        'is_admin': bool,
        'language': Optional(unicode),
        'remote': bool,
    }
    w_attributes = ["additional_parameters", "create_share", "email", "is_admin", "language", "remote"]
    r_attributes = ["create_share", "email", "id", "is_admin", "language", "remote"]
    h_attributes = []
    op_values = {'create_share': True, 'language': None}

    @classmethod
    def name(cls):
        return u'LocalInvite'

    @classmethod
    def new_object(cls):
        return LocalInvite()


class LocalInvite(ClientObject):

    def setadditional_parameters(self, value):
        self.additional_parameters = value

    def setcreate_share(self, value):
        self.create_share = value

    def setemail(self, value):
        self.email = value

    def setis_admin(self, value):
        self.is_admin = value

    def setlanguage(self, value):
        self.language = value

    def setremote(self, value):
        self.remote = value

    def getcreate_share(self):
        return self.create_share

    def getemail(self):
        return self.email

    def getid(self):
        return self.id

    def getis_admin(self):
        return self.is_admin

    def getlanguage(self):
        return self.language

    def getremote(self):
        return self.remote
    __instantiator__ = LocalInviteInstantiator
register_instantiator('unicorn_api', LocalInviteInstantiator, True)
