#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v6.sv0.oauth2 import OAuth2Service
from unicorn_api.v6.sv0.oauth2.OAuth2UserInfo import OAuth2UserInfo

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class OAuth2Authentication(APIService):


    def get_access_token(self, service, code, state, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['code'] = code
        params['state'] = state
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.get_access_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['access_token']

    def get_access_token_async(self, service, code, state, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['code'] = code
        params['state'] = state
        url = "api/external/6.0/oauth2.OAuth2Authentication.get_access_token"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_auth_token(self, service, code, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['code'] = code
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.get_auth_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['auth_token']

    def get_auth_token_async(self, service, code, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['code'] = code
        url = "api/external/6.0/oauth2.OAuth2Authentication.get_auth_token"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_auth_url(self, service, state, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['state'] = state
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.get_auth_url"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['url']

    def get_auth_url_async(self, service, state, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['state'] = state
        url = "api/external/6.0/oauth2.OAuth2Authentication.get_auth_url"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_info(self, service, auth_token, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['auth_token'] = auth_token
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.get_info"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['user_info']

    def get_info_async(self, service, auth_token, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['auth_token'] = auth_token
        url = "api/external/6.0/oauth2.OAuth2Authentication.get_info"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def refresh_access_token(self, service, refresh_token, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['refresh_token'] = refresh_token
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.refresh_access_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['access_token']

    def refresh_access_token_async(self, service, refresh_token, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['refresh_token'] = refresh_token
        url = "api/external/6.0/oauth2.OAuth2Authentication.refresh_access_token"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def refresh_auth_token(self, service, old_auth_token, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['service'] = service
        params['old_auth_token'] = old_auth_token
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/oauth2.OAuth2Authentication.refresh_auth_token"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['auth_token']

    def refresh_auth_token_async(self, service, old_auth_token, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['service'] = service
        params['old_auth_token'] = old_auth_token
        url = "api/external/6.0/oauth2.OAuth2Authentication.refresh_auth_token"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
