#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v6.sv0.quotas.Quota import Quota

from transformer.lib import Ciphered


class SimpleUserInstantiator(Instantiator):
    version = 6
    sub_version = 0
    attributes = {
        'comment': Optional(unicode),
        'email': Optional(unicode),
        'firstname': Optional(unicode),
        'id': int,
        'is_admin': bool,
        'lastname': Optional(unicode),
        'login': unicode,
        'password': Optional(Ciphered),
        'quota': Optional(Quota),
    }
    w_attributes = ["comment", "email", "firstname", "is_admin", "lastname", "login", "password", "quota"]
    r_attributes = ["comment", "email", "firstname", "id", "is_admin", "lastname", "login", "quota"]
    h_attributes = []
    op_values = {'comment': None, 'firstname': None, 'lastname': None, 'quota': None, 'password': None, 'email': None}

    @classmethod
    def name(cls):
        return u'SimpleUser'

    @classmethod
    def new_object(cls):
        return SimpleUser()


class SimpleUser(ClientObject):

    def setcomment(self, value):
        self.comment = value

    def setemail(self, value):
        self.email = value

    def setfirstname(self, value):
        self.firstname = value

    def setis_admin(self, value):
        self.is_admin = value

    def setlastname(self, value):
        self.lastname = value

    def setlogin(self, value):
        self.login = value

    def setpassword(self, value):
        self.password = value

    def setquota(self, value):
        self.quota = value

    def getcomment(self):
        return self.comment

    def getemail(self):
        return self.email

    def getfirstname(self):
        return self.firstname

    def getid(self):
        return self.id

    def getis_admin(self):
        return self.is_admin

    def getlastname(self):
        return self.lastname

    def getlogin(self):
        return self.login

    def getquota(self):
        return self.quota
    __instantiator__ = SimpleUserInstantiator
register_instantiator('unicorn_api', SimpleUserInstantiator, True)
