#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Apr 30 2015 11:23:46
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v6.sv0.snmp.SnmpConfig import SnmpConfig
from unicorn_api.v6.sv0.snmp import SnmpVersion
from unicorn_api.v6.sv0.snmp.AvailableTrap import AvailableTrap
from unicorn_api.v6.sv0.snmp.TrapTarget import TrapTarget
from unicorn_api.v6.sv0.snmp.MibDownloadLink import MibDownloadLink

from transformer.lib import List, ListInfo, ResultSet

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class SnmpAdministration(APIService):


    def add_trap_address(self, hostname, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['hostname'] = hostname
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.add_trap_address"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['trap_target']

    def add_trap_address_async(self, hostname, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['hostname'] = hostname
        url = "api/external/6.0/snmp.SnmpAdministration.add_trap_address"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def delete_trap_address(self, hostname, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['hostname'] = hostname
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.delete_trap_address"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def delete_trap_address_async(self, hostname, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['hostname'] = hostname
        url = "api/external/6.0/snmp.SnmpAdministration.delete_trap_address"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def download_mib(self, async_client_ref, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['async_client_ref'] = async_client_ref
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.download_mib"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['async_job_id']


    def download_mib_result(self, async_job_id,__client__=None, raw_output=False, timeout=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__

        url = "api/external/6.0/snmp.SnmpAdministration.download_mib_result"
        context = ClientTransportSender.get_context('unicorn_api')
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['download_link']



    def download_mib_wait(self, async_client_ref, __client__=None, timeout=None, raw_output=False, nb_timeout=None, sleep=None, nb_poll=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.download_mib"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        async_job_id = res['async_job_id']
        res = ClientTransportSender.get_job_status(async_job_id)
        nbPoll = nb_poll if nb_poll is not None else 200
        nbTimeout = nb_timeout if nb_timeout is not None else 4
        sleepTime = sleep if sleep is not None else 3
        currentPoll = currentTimeout = 0
        while 2 == res.status and currentPoll < nbPoll:
            time.sleep(sleepTime)
            try:
                res = ClientTransportSender.get_job_status(async_job_id)
            except HTTPError, exc:
                if exc.status == "Timeout":
                    currentTimeout += 1
                    if currentTimeout >= nbTimeout:
                        raise
                    continue
            currentPoll += 1
        if 2 != res.status:
            return self.download_mib_result(async_job_id, raw_output=raw_output)
        raise Exception('Failed to get result')


    def get_config(self, with_parameters, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['with_parameters'] = with_parameters
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.get_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['config']

    def get_config_async(self, with_parameters, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        url = "api/external/6.0/snmp.SnmpAdministration.get_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_trap_addresses(self, listInfo, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['listInfo'] = listInfo
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.get_trap_addresses"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['trap_target_list']

    def get_trap_addresses_async(self, listInfo, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['listInfo'] = listInfo
        url = "api/external/6.0/snmp.SnmpAdministration.get_trap_addresses"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_traps(self, listInfo, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['listInfo'] = listInfo
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.get_traps"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['trap_list']

    def get_traps_async(self, listInfo, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['listInfo'] = listInfo
        url = "api/external/6.0/snmp.SnmpAdministration.get_traps"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_traps_enabled(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.get_traps_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['enabled']

    def get_traps_enabled_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/6.0/snmp.SnmpAdministration.get_traps_enabled"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_config(self, config, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['config'] = config
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.set_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_config_async(self, config, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['config'] = config
        url = "api/external/6.0/snmp.SnmpAdministration.set_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_enabled(self, enabled, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.set_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['config']

    def set_enabled_async(self, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enabled'] = enabled
        url = "api/external/6.0/snmp.SnmpAdministration.set_enabled"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_traps(self, trap_list, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['trap_list'] = trap_list
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.set_traps"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_traps_async(self, trap_list, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['trap_list'] = trap_list
        url = "api/external/6.0/snmp.SnmpAdministration.set_traps"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_traps_enabled(self, enabled, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.set_traps_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_traps_enabled_async(self, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enabled'] = enabled
        url = "api/external/6.0/snmp.SnmpAdministration.set_traps_enabled"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_version(self, version, with_parameters, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['version'] = version
        params['with_parameters'] = with_parameters
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/6.0/snmp.SnmpAdministration.set_version"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['config']

    def set_version_async(self, version, with_parameters, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['version'] = version
        params['with_parameters'] = with_parameters
        url = "api/external/6.0/snmp.SnmpAdministration.set_version"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
