#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Ciphered


class AuthenticationConfigInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'domain': Optional(unicode),
        'login': Optional(unicode),
        'password': Optional(Ciphered),
    }
    w_attributes = ["domain", "login", "password"]
    r_attributes = ["domain", "login", "password"]
    h_attributes = []
    op_values = {'domain': None, 'password': None, 'login': None}

    @classmethod
    def name(cls):
        return u'AuthenticationConfig'

    @classmethod
    def new_object(cls):
        return AuthenticationConfig()


class AuthenticationConfig(ClientObject):

    def setdomain(self, value):
        self.domain = value

    def setlogin(self, value):
        self.login = value

    def setpassword(self, value):
        self.password = value

    def getdomain(self):
        return self.domain

    def getlogin(self):
        return self.login

    def getpassword(self):
        return self.password
    __instantiator__ = AuthenticationConfigInstantiator
register_instantiator('unicorn_api', AuthenticationConfigInstantiator, True)
