#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup.AuthenticationConfig import AuthenticationConfig
from unicorn_api.v7.sv0.backup.FolderOptions import FolderOptions


class FolderInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'auth_info': Optional(AuthenticationConfig),
        'id': int,
        'options': Optional(FolderOptions),
        'unique_sub_path': Optional(unicode),
        'unique_sub_path_string': unicode,
        'uri': unicode,
    }
    w_attributes = ["auth_info", "options", "unique_sub_path", "uri"]
    r_attributes = ["auth_info", "id", "options", "unique_sub_path", "unique_sub_path_string", "uri"]
    h_attributes = []
    op_values = {'auth_info': None, 'options': None, 'unique_sub_path': None}

    @classmethod
    def name(cls):
        return u'Folder'

    @classmethod
    def new_object(cls):
        return Folder()


class Folder(ClientObject):

    def setauth_info(self, value):
        self.auth_info = value

    def setoptions(self, value):
        self.options = value

    def setunique_sub_path(self, value):
        self.unique_sub_path = value

    def seturi(self, value):
        self.uri = value

    def getauth_info(self):
        return self.auth_info

    def getid(self):
        return self.id

    def getoptions(self):
        return self.options

    def getunique_sub_path(self):
        return self.unique_sub_path

    def getunique_sub_path_string(self):
        return self.unique_sub_path_string

    def geturi(self):
        return self.uri
    __instantiator__ = FolderInstantiator
register_instantiator('unicorn_api', FolderInstantiator, True)
