#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup import SyncConflictResolutionPolicy


class FolderOptionsInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'auto_eject': Optional(bool),
        'auto_start': Optional(bool),
        'compression': Optional(bool),
        'delete': Optional(bool),
        'differential_transfer': Optional(bool),
        'encryption': Optional(bool),
        'sync_policy': Optional(SyncConflictResolutionPolicy),
        'use_proxy': Optional(bool),
    }
    w_attributes = ["auto_eject", "auto_start", "compression", "delete", "differential_transfer", "encryption", "sync_policy", "use_proxy"]
    r_attributes = ["auto_eject", "auto_start", "compression", "delete", "differential_transfer", "encryption", "sync_policy", "use_proxy"]
    h_attributes = []
    op_values = {'use_proxy': None, 'compression': None, 'encryption': None, 'auto_eject': None, 'differential_transfer': None, 'auto_start': None, 'sync_policy': None, 'delete': None}

    @classmethod
    def name(cls):
        return u'FolderOptions'

    @classmethod
    def new_object(cls):
        return FolderOptions()


class FolderOptions(ClientObject):

    def setauto_eject(self, value):
        self.auto_eject = value

    def setauto_start(self, value):
        self.auto_start = value

    def setcompression(self, value):
        self.compression = value

    def setdelete(self, value):
        self.delete = value

    def setdifferential_transfer(self, value):
        self.differential_transfer = value

    def setencryption(self, value):
        self.encryption = value

    def setsync_policy(self, value):
        self.sync_policy = value

    def setuse_proxy(self, value):
        self.use_proxy = value

    def getauto_eject(self):
        return self.auto_eject

    def getauto_start(self):
        return self.auto_start

    def getcompression(self):
        return self.compression

    def getdelete(self):
        return self.delete

    def getdifferential_transfer(self):
        return self.differential_transfer

    def getencryption(self):
        return self.encryption

    def getsync_policy(self):
        return self.sync_policy

    def getuse_proxy(self):
        return self.use_proxy
    __instantiator__ = FolderOptionsInstantiator
register_instantiator('unicorn_api', FolderOptionsInstantiator, True)
