#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup import JobType
from unicorn_api.v7.sv0.backup import JobKind
from unicorn_api.v7.sv0.backup.Folder import Folder
from unicorn_api.v7.sv0.backup import JobStatus
from unicorn_api.v7.sv0.backup.Scheduler import Scheduler
from unicorn_api.v7.sv0.backup.JobProgress import JobProgress
from unicorn_api.v7.sv0.backup.JobHistoryEntry import JobHistoryEntry

from transformer.lib import List


class JobInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'description': Optional(unicode),
        'destinations': List(Folder),
        'enabled': bool,
        'id': int,
        'kind': JobKind,
        'last_history_entry': JobHistoryEntry,
        'name': unicode,
        'owner_id': int,
        'owner_login': unicode,
        'progress': JobProgress,
        'scheduler': Optional(Scheduler),
        'sources': List(Folder),
        'status': JobStatus,
        'type': JobType,
    }
    w_attributes = ["description", "destinations", "kind", "name", "scheduler", "sources", "type"]
    r_attributes = ["description", "destinations", "enabled", "id", "kind", "last_history_entry", "name", "owner_id", "owner_login", "progress", "scheduler", "sources", "status", "type"]
    h_attributes = ["last_history_entry", "progress"]
    op_values = {'description': None, 'scheduler': None}

    @classmethod
    def name(cls):
        return u'Job'

    @classmethod
    def new_object(cls):
        return Job()


class Job(ClientObject):

    def setdescription(self, value):
        self.description = value

    def setdestinations(self, value):
        self.destinations = value

    def setkind(self, value):
        self.kind = value

    def setname(self, value):
        self.name = value

    def setscheduler(self, value):
        self.scheduler = value

    def setsources(self, value):
        self.sources = value

    def settype(self, value):
        self.type = value

    def getdescription(self):
        return self.description

    def getdestinations(self):
        return self.destinations

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def getkind(self):
        return self.kind

    def getlast_history_entry(self):
        return self.last_history_entry

    def getname(self):
        return self.name

    def getowner_id(self):
        return self.owner_id

    def getowner_login(self):
        return self.owner_login

    def getprogress(self):
        return self.progress

    def getscheduler(self):
        return self.scheduler

    def getsources(self):
        return self.sources

    def getstatus(self):
        return self.status

    def gettype(self):
        return self.type
    __instantiator__ = JobInstantiator
register_instantiator('unicorn_api', JobInstantiator, True)
