#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup import JobCompletionStatus

from transformer.lib import Date, Long


class JobHistoryEntryInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'end_date': Date,
        'error_code': int,
        'error_message': unicode,
        'is_valid': bool,
        'n_bytes_total': Long,
        'n_bytes_transferred': Long,
        'n_files_total': Long,
        'n_files_transferred': Long,
        'start_date': Date,
        'status': JobCompletionStatus,
        'unique_id': int,
    }
    w_attributes = []
    r_attributes = ["end_date", "error_code", "error_message", "is_valid", "n_bytes_total", "n_bytes_transferred", "n_files_total", "n_files_transferred", "start_date", "status", "unique_id"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'JobHistoryEntry'

    @classmethod
    def new_object(cls):
        return JobHistoryEntry()


class JobHistoryEntry(ClientObject):

    def getend_date(self):
        return self.end_date

    def geterror_code(self):
        return self.error_code

    def geterror_message(self):
        return self.error_message

    def getis_valid(self):
        return self.is_valid

    def getn_bytes_total(self):
        return self.n_bytes_total

    def getn_bytes_transferred(self):
        return self.n_bytes_transferred

    def getn_files_total(self):
        return self.n_files_total

    def getn_files_transferred(self):
        return self.n_files_transferred

    def getstart_date(self):
        return self.start_date

    def getstatus(self):
        return self.status

    def getunique_id(self):
        return self.unique_id
    __instantiator__ = JobHistoryEntryInstantiator
register_instantiator('unicorn_api', JobHistoryEntryInstantiator, True)
