#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup import JobRunningState

from transformer.lib import Double, Long, Date


class JobProgressInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'bytes_per_second': Long,
        'hot_filename': unicode,
        'hot_percentage': Double,
        'n_bytes_to_transfer': Long,
        'n_bytes_total': Long,
        'n_bytes_transferred': Long,
        'n_files_to_transfer': Long,
        'n_files_total': Long,
        'n_files_transferred': Long,
        'percentage': Double,
        'start_date': Date,
        'state': JobRunningState,
    }
    w_attributes = []
    r_attributes = ["bytes_per_second", "hot_filename", "hot_percentage", "n_bytes_to_transfer", "n_bytes_total", "n_bytes_transferred", "n_files_to_transfer", "n_files_total", "n_files_transferred", "percentage", "start_date", "state"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'JobProgress'

    @classmethod
    def new_object(cls):
        return JobProgress()


class JobProgress(ClientObject):

    def getbytes_per_second(self):
        return self.bytes_per_second

    def gethot_filename(self):
        return self.hot_filename

    def gethot_percentage(self):
        return self.hot_percentage

    def getn_bytes_to_transfer(self):
        return self.n_bytes_to_transfer

    def getn_bytes_total(self):
        return self.n_bytes_total

    def getn_bytes_transferred(self):
        return self.n_bytes_transferred

    def getn_files_to_transfer(self):
        return self.n_files_to_transfer

    def getn_files_total(self):
        return self.n_files_total

    def getn_files_transferred(self):
        return self.n_files_transferred

    def getpercentage(self):
        return self.percentage

    def getstart_date(self):
        return self.start_date

    def getstate(self):
        return self.state
    __instantiator__ = JobProgressInstantiator
register_instantiator('unicorn_api', JobProgressInstantiator, True)
