#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup.Folder import Folder

from transformer.lib import List


class RestoreOptionsInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'clear_dst': Optional(bool),
        'custom_restore_dst': Optional(Folder),
        'excludes': Optional(List(unicode)),
        'includes': Optional(List(unicode)),
    }
    w_attributes = ["clear_dst", "custom_restore_dst", "excludes", "includes"]
    r_attributes = ["clear_dst", "custom_restore_dst", "excludes", "includes"]
    h_attributes = []
    op_values = {'excludes': None, 'clear_dst': None, 'custom_restore_dst': None, 'includes': None}

    @classmethod
    def name(cls):
        return u'RestoreOptions'

    @classmethod
    def new_object(cls):
        return RestoreOptions()


class RestoreOptions(ClientObject):

    def setclear_dst(self, value):
        self.clear_dst = value

    def setcustom_restore_dst(self, value):
        self.custom_restore_dst = value

    def setexcludes(self, value):
        self.excludes = value

    def setincludes(self, value):
        self.includes = value

    def getclear_dst(self):
        return self.clear_dst

    def getcustom_restore_dst(self):
        return self.custom_restore_dst

    def getexcludes(self):
        return self.excludes

    def getincludes(self):
        return self.includes
    __instantiator__ = RestoreOptionsInstantiator
register_instantiator('unicorn_api', RestoreOptionsInstantiator, True)
