#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.backup import SchedulerType

from transformer.lib import List, Time


class SchedulerInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'days': Optional(List(int)),
        'frequency': Optional(int),
        'next_scheduled_time': Time,
        'start_time': Time,
        'stop_time': Optional(Time),
        'type': SchedulerType,
    }
    w_attributes = ["days", "frequency", "start_time", "stop_time", "type"]
    r_attributes = ["days", "frequency", "next_scheduled_time", "start_time", "stop_time", "type"]
    h_attributes = []
    op_values = {'frequency': None, 'days': None, 'stop_time': None}

    @classmethod
    def name(cls):
        return u'Scheduler'

    @classmethod
    def new_object(cls):
        return Scheduler()


class Scheduler(ClientObject):

    def setdays(self, value):
        self.days = value

    def setfrequency(self, value):
        self.frequency = value

    def setstart_time(self, value):
        self.start_time = value

    def setstop_time(self, value):
        self.stop_time = value

    def settype(self, value):
        self.type = value

    def getdays(self):
        return self.days

    def getfrequency(self):
        return self.frequency

    def getnext_scheduled_time(self):
        return self.next_scheduled_time

    def getstart_time(self):
        return self.start_time

    def getstop_time(self):
        return self.stop_time

    def gettype(self):
        return self.type
    __instantiator__ = SchedulerInstantiator
register_instantiator('unicorn_api', SchedulerInstantiator, True)
