#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Enum
class JobCompletionStatus(Enum):
    UNKNOWN= -1
    DONE= 0
    CANCELLED= 1
    FAILED= 2
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class JobKind(Enum):
    UNKNOWN= -1
    FULL= 0
    INCREMENTAL= 1
    MIRROR= 2
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class JobRunningState(Enum):
    UNKNOWN= -1
    INIT= 0
    SCAN= 1
    TRANSFER= 2
    FINISHING= 3
    WAITING= 4
    VERIFYING= 5
    COMPLETED= 6
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class JobStatus(Enum):
    UNKNOWN= -1
    INACTIVE= 0
    ENQUEUED= 1
    RUNNING= 2
    PAUSED= 3
    BUSY= 4
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class JobType(Enum):
    UNKNOWN= -1
    BACKUP= 0
    RESTORE= 1
    SYNC= 2
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class SchedulerType(Enum):
    UNKNOWN= -1
    DAILY= 0
    WEEKLY= 1
    MONTHLY= 2
    CUSTOM= 3
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
class SyncConflictResolutionPolicy(Enum):
    UNKNOWN= -1
    DEFAULT= 0
    LOCAL= 1
    SERVER= 2
    RENAME= 3
    @classmethod
    def from_cli(cls, value):
        return cls(getattr(cls, value))
