#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.domain import DomainStates
from unicorn_api.v7.sv0.domain import SyncStatus

from transformer.lib import IP


class DomainConfigInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'dc_hostname': unicode,
        'dc_ip': IP,
        'enabled': bool,
        'error_message': unicode,
        'fqdn': unicode,
        'locked': bool,
        'short_name': unicode,
        'status': DomainStates,
        'sync_status': SyncStatus,
    }
    w_attributes = ["dc_hostname", "dc_ip", "enabled", "fqdn", "short_name"]
    r_attributes = ["dc_hostname", "dc_ip", "enabled", "error_message", "fqdn", "locked", "short_name", "status", "sync_status"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'DomainConfig'

    @classmethod
    def new_object(cls):
        return DomainConfig()


class DomainConfig(ClientObject):

    def setdc_hostname(self, value):
        self.dc_hostname = value

    def setdc_ip(self, value):
        self.dc_ip = value

    def setenabled(self, value):
        self.enabled = value

    def setfqdn(self, value):
        self.fqdn = value

    def setshort_name(self, value):
        self.short_name = value

    def getdc_hostname(self):
        return self.dc_hostname

    def getdc_ip(self):
        return self.dc_ip

    def getenabled(self):
        return self.enabled

    def geterror_message(self):
        return self.error_message

    def getfqdn(self):
        return self.fqdn

    def getlocked(self):
        return self.locked

    def getshort_name(self):
        return self.short_name

    def getstatus(self):
        return self.status

    def getsync_status(self):
        return self.sync_status
    __instantiator__ = DomainConfigInstantiator
register_instantiator('unicorn_api', DomainConfigInstantiator, True)
