#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.download import DownloadType
from unicorn_api.v7.sv0.download import DownloadStatus

from transformer.lib import Long


class DownloadInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'current_download_rate': Long,
        'current_upload_rate': Long,
        'dest_path': unicode,
        'downloaded_size': Long,
        'from_path': unicode,
        'id': int,
        'name': unicode,
        'progress': int,
        'share_id': int,
        'status': DownloadStatus,
        'to_path': unicode,
        'total_size': Long,
        'type': DownloadType,
    }
    w_attributes = ["current_download_rate", "current_upload_rate", "downloaded_size", "from_path", "name", "progress", "share_id", "status", "to_path", "total_size", "type"]
    r_attributes = ["current_download_rate", "current_upload_rate", "dest_path", "downloaded_size", "from_path", "id", "name", "progress", "share_id", "status", "to_path", "total_size", "type"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'Download'

    @classmethod
    def new_object(cls):
        return Download()


class Download(ClientObject):

    def setcurrent_download_rate(self, value):
        self.current_download_rate = value

    def setcurrent_upload_rate(self, value):
        self.current_upload_rate = value

    def setdownloaded_size(self, value):
        self.downloaded_size = value

    def setfrom_path(self, value):
        self.from_path = value

    def setname(self, value):
        self.name = value

    def setprogress(self, value):
        self.progress = value

    def setshare_id(self, value):
        self.share_id = value

    def setstatus(self, value):
        self.status = value

    def setto_path(self, value):
        self.to_path = value

    def settotal_size(self, value):
        self.total_size = value

    def settype(self, value):
        self.type = value

    def getcurrent_download_rate(self):
        return self.current_download_rate

    def getcurrent_upload_rate(self):
        return self.current_upload_rate

    def getdest_path(self):
        return self.dest_path

    def getdownloaded_size(self):
        return self.downloaded_size

    def getfrom_path(self):
        return self.from_path

    def getid(self):
        return self.id

    def getname(self):
        return self.name

    def getprogress(self):
        return self.progress

    def getshare_id(self):
        return self.share_id

    def getstatus(self):
        return self.status

    def getto_path(self):
        return self.to_path

    def gettotal_size(self):
        return self.total_size

    def gettype(self):
        return self.type
    __instantiator__ = DownloadInstantiator
register_instantiator('unicorn_api', DownloadInstantiator, True)
