#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Long


class DownloadConfigInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'dl_rate_limit': Long,
        'enabled': bool,
        'max_active_downloads': int,
        'peer_port': int,
        'up_rate_limit': Long,
    }
    w_attributes = ["dl_rate_limit", "enabled", "max_active_downloads", "peer_port", "up_rate_limit"]
    r_attributes = ["dl_rate_limit", "enabled", "max_active_downloads", "peer_port", "up_rate_limit"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'DownloadConfig'

    @classmethod
    def new_object(cls):
        return DownloadConfig()


class DownloadConfig(ClientObject):

    def setdl_rate_limit(self, value):
        self.dl_rate_limit = value

    def setenabled(self, value):
        self.enabled = value

    def setmax_active_downloads(self, value):
        self.max_active_downloads = value

    def setpeer_port(self, value):
        self.peer_port = value

    def setup_rate_limit(self, value):
        self.up_rate_limit = value

    def getdl_rate_limit(self):
        return self.dl_rate_limit

    def getenabled(self):
        return self.enabled

    def getmax_active_downloads(self):
        return self.max_active_downloads

    def getpeer_port(self):
        return self.peer_port

    def getup_rate_limit(self):
        return self.up_rate_limit
    __instantiator__ = DownloadConfigInstantiator
register_instantiator('unicorn_api', DownloadConfigInstantiator, True)
