#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.network_security import CertificateStatus
from unicorn_api.v7.sv0.network_security.CertificateIssuerInfo import CertificateIssuerInfo

from transformer.lib import Date


class CertificateInfoInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'end_date': Date,
        'issued_by': CertificateIssuerInfo,
        'issued_for': CertificateIssuerInfo,
        'signature_algorithm': unicode,
        'start_date': Date,
        'status': CertificateStatus,
    }
    w_attributes = []
    r_attributes = ["end_date", "issued_by", "issued_for", "signature_algorithm", "start_date", "status"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'CertificateInfo'

    @classmethod
    def new_object(cls):
        return CertificateInfo()


class CertificateInfo(ClientObject):

    def getend_date(self):
        return self.end_date

    def getissued_by(self):
        return self.issued_by

    def getissued_for(self):
        return self.issued_for

    def getsignature_algorithm(self):
        return self.signature_algorithm

    def getstart_date(self):
        return self.start_date

    def getstatus(self):
        return self.status
    __instantiator__ = CertificateInfoInstantiator
register_instantiator('unicorn_api', CertificateInfoInstantiator, True)
