#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Time


class Fail2BanConfigInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'bantime': Optional(Time),
        'enabled': Optional(bool),
        'findtime': Optional(Time),
        'maxretry': Optional(int),
    }
    w_attributes = ["bantime", "enabled", "findtime", "maxretry"]
    r_attributes = ["bantime", "enabled", "findtime", "maxretry"]
    h_attributes = []
    op_values = {'maxretry': None, 'enabled': None, 'findtime': None, 'bantime': None}

    @classmethod
    def name(cls):
        return u'Fail2BanConfig'

    @classmethod
    def new_object(cls):
        return Fail2BanConfig()


class Fail2BanConfig(ClientObject):

    def setbantime(self, value):
        self.bantime = value

    def setenabled(self, value):
        self.enabled = value

    def setfindtime(self, value):
        self.findtime = value

    def setmaxretry(self, value):
        self.maxretry = value

    def getbantime(self):
        return self.bantime

    def getenabled(self):
        return self.enabled

    def getfindtime(self):
        return self.findtime

    def getmaxretry(self):
        return self.maxretry
    __instantiator__ = Fail2BanConfigInstantiator
register_instantiator('unicorn_api', Fail2BanConfigInstantiator, True)
