#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject

from transformer.lib import Time


class PowersaveConfigInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'sata_led_enabled': bool,
        'schedule_poweroff_enabled': bool,
        'schedule_poweron_enabled': bool,
        'sleepmode_enabled': bool,
        'spindown_enabled': bool,
        'spindown_wait_time': Time,
        'system_led_enabled': bool,
        'wake_on_button_enabled': bool,
        'wake_on_lan_enabled': bool,
    }
    w_attributes = ["sata_led_enabled", "schedule_poweroff_enabled", "schedule_poweron_enabled", "sleepmode_enabled", "spindown_enabled", "spindown_wait_time", "system_led_enabled", "wake_on_button_enabled", "wake_on_lan_enabled"]
    r_attributes = ["sata_led_enabled", "schedule_poweroff_enabled", "schedule_poweron_enabled", "sleepmode_enabled", "spindown_enabled", "spindown_wait_time", "system_led_enabled", "wake_on_button_enabled", "wake_on_lan_enabled"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'PowersaveConfig'

    @classmethod
    def new_object(cls):
        return PowersaveConfig()


class PowersaveConfig(ClientObject):

    def setsata_led_enabled(self, value):
        self.sata_led_enabled = value

    def setschedule_poweroff_enabled(self, value):
        self.schedule_poweroff_enabled = value

    def setschedule_poweron_enabled(self, value):
        self.schedule_poweron_enabled = value

    def setsleepmode_enabled(self, value):
        self.sleepmode_enabled = value

    def setspindown_enabled(self, value):
        self.spindown_enabled = value

    def setspindown_wait_time(self, value):
        self.spindown_wait_time = value

    def setsystem_led_enabled(self, value):
        self.system_led_enabled = value

    def setwake_on_button_enabled(self, value):
        self.wake_on_button_enabled = value

    def setwake_on_lan_enabled(self, value):
        self.wake_on_lan_enabled = value

    def getsata_led_enabled(self):
        return self.sata_led_enabled

    def getschedule_poweroff_enabled(self):
        return self.schedule_poweroff_enabled

    def getschedule_poweron_enabled(self):
        return self.schedule_poweron_enabled

    def getsleepmode_enabled(self):
        return self.sleepmode_enabled

    def getspindown_enabled(self):
        return self.spindown_enabled

    def getspindown_wait_time(self):
        return self.spindown_wait_time

    def getsystem_led_enabled(self):
        return self.system_led_enabled

    def getwake_on_button_enabled(self):
        return self.wake_on_button_enabled

    def getwake_on_lan_enabled(self):
        return self.wake_on_lan_enabled
    __instantiator__ = PowersaveConfigInstantiator
register_instantiator('unicorn_api', PowersaveConfigInstantiator, True)
