#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.powersave import Weekday
from unicorn_api.v7.sv0.powersave import ScheduleAction

from transformer.lib import Time


class SchedulePowerInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'action': ScheduleAction,
        'enabled': bool,
        'id': int,
        'time': Time,
        'weekday': Weekday,
    }
    w_attributes = ["action", "enabled", "time", "weekday"]
    r_attributes = ["action", "enabled", "id", "time", "weekday"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'SchedulePower'

    @classmethod
    def new_object(cls):
        return SchedulePower()


class SchedulePower(ClientObject):

    def setaction(self, value):
        self.action = value

    def setenabled(self, value):
        self.enabled = value

    def settime(self, value):
        self.time = value

    def setweekday(self, value):
        self.weekday = value

    def getaction(self):
        return self.action

    def getenabled(self):
        return self.enabled

    def getid(self):
        return self.id

    def gettime(self):
        return self.time

    def getweekday(self):
        return self.weekday
    __instantiator__ = SchedulePowerInstantiator
register_instantiator('unicorn_api', SchedulePowerInstantiator, True)
