#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.remote_access_simple import RemoteAccessProtocol
from unicorn_api.v7.sv0.remote_access_simple import RemoteAccessMode
from unicorn_api.v7.sv0.remote_access_simple import RemoteAccessStatus


class RemoteAccessSimpleInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'enabled': bool,
        'local_port': int,
        'mode': RemoteAccessMode,
        'name': unicode,
        'name_expiration_time': int,
        'protocol': RemoteAccessProtocol,
        'remote_port': int,
        'server_public_address': unicode,
        'status': RemoteAccessStatus,
    }
    w_attributes = ["enabled", "local_port", "mode", "name", "protocol", "remote_port"]
    r_attributes = ["enabled", "local_port", "mode", "name", "name_expiration_time", "protocol", "remote_port", "server_public_address", "status"]
    h_attributes = []
    op_values = {}

    @classmethod
    def name(cls):
        return u'RemoteAccessSimple'

    @classmethod
    def new_object(cls):
        return RemoteAccessSimple()


class RemoteAccessSimple(ClientObject):

    def setenabled(self, value):
        self.enabled = value

    def setlocal_port(self, value):
        self.local_port = value

    def setmode(self, value):
        self.mode = value

    def setname(self, value):
        self.name = value

    def setprotocol(self, value):
        self.protocol = value

    def setremote_port(self, value):
        self.remote_port = value

    def getenabled(self):
        return self.enabled

    def getlocal_port(self):
        return self.local_port

    def getmode(self):
        return self.mode

    def getname(self):
        return self.name

    def getname_expiration_time(self):
        return self.name_expiration_time

    def getprotocol(self):
        return self.protocol

    def getremote_port(self):
        return self.remote_port

    def getserver_public_address(self):
        return self.server_public_address

    def getstatus(self):
        return self.status
    __instantiator__ = RemoteAccessSimpleInstantiator
register_instantiator('unicorn_api', RemoteAccessSimpleInstantiator, True)
