#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v7.sv0.sdrive.SdriveAccountInfo import SdriveAccountInfo
from unicorn_api.v7.sv0.sdrive import SdriveUserStatus
from unicorn_api.v7.sv0.sdrive.Invite import Invite
from unicorn_api.v7.sv0.sdrive.SdriveInfo import SdriveInfo
from unicorn_api.v7.sv0.sdrive.Version import Version
from unicorn_api.v7.sv0.sdrive.InviteStatus import InviteStatus
from unicorn_api.v7.sv0.sdrive.LoginPasswordTuple import LoginPasswordTuple

from transformer.lib import Ciphered, List, Dict, ListInfo, ResultSet, Blob

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class SdriveManagement(APIService):


    def accept_invite(self, sdrive_id, accept, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['accept'] = accept
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.accept_invite"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def accept_invite_async(self, sdrive_id, accept, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['accept'] = accept
        url = "api/local/7.0/sdrive.Management.accept_invite"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def add_invite_entry(self, invite_id, sdrive_id, sdrive_email, user_id, is_final_sdrive_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['invite_id'] = invite_id
        params['sdrive_id'] = sdrive_id
        params['sdrive_email'] = sdrive_email
        params['user_id'] = user_id
        params['is_final_sdrive_id'] = is_final_sdrive_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.add_invite_entry"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def add_invite_entry_async(self, invite_id, sdrive_id, sdrive_email, user_id, is_final_sdrive_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['invite_id'] = invite_id
        params['sdrive_id'] = sdrive_id
        params['sdrive_email'] = sdrive_email
        params['user_id'] = user_id
        params['is_final_sdrive_id'] = is_final_sdrive_id
        url = "api/local/7.0/sdrive.Management.add_invite_entry"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def associate_device(self, sdrive_user, sdrive_password, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.associate_device"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def associate_device_async(self, sdrive_user, sdrive_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        url = "api/external/7.0/sdrive.Management.associate_device"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def associate_local_account(self, sdrive_id, login, password, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['login'] = login
        params['password'] = password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.associate_local_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['status']

    def associate_local_account_async(self, sdrive_id, login, password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['login'] = login
        params['password'] = password
        url = "api/local/7.0/sdrive.Management.associate_local_account"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def associate_sdrive_account(self, sdrive_id, final_sdrive_id, final_email, invite_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['final_sdrive_id'] = final_sdrive_id
        params['final_email'] = final_email
        params['invite_id'] = invite_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.associate_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['status']

    def associate_sdrive_account_async(self, sdrive_id, final_sdrive_id, final_email, invite_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        params['final_sdrive_id'] = final_sdrive_id
        params['final_email'] = final_email
        params['invite_id'] = invite_id
        url = "api/local/7.0/sdrive.Management.associate_sdrive_account"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def confirm_sdrive_user(self, user_email, confirmation_code, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['user_email'] = user_email
        params['confirmation_code'] = confirmation_code
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.confirm_sdrive_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def confirm_sdrive_user_async(self, user_email, confirmation_code, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['confirmation_code'] = confirmation_code
        url = "api/external/7.0/sdrive.Management.confirm_sdrive_user"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def create_file_http_download_link(self, path, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['path'] = path
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.create_file_http_download_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['url']

    def create_file_http_download_link_async(self, path, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['path'] = path
        url = "api/external/7.0/sdrive.Management.create_file_http_download_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def create_file_http_upload_link(self, path, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['path'] = path
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.create_file_http_upload_link"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['url']

    def create_file_http_upload_link_async(self, path, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['path'] = path
        url = "api/external/7.0/sdrive.Management.create_file_http_upload_link"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def create_sdrive_user(self, user_email, user_password, password_hint, secured, locale, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        params['password_hint'] = password_hint
        params['secured'] = secured
        params['locale'] = locale
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.create_sdrive_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def create_sdrive_user_async(self, user_email, user_password, password_hint, secured, locale, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        params['password_hint'] = password_hint
        params['secured'] = secured
        params['locale'] = locale
        url = "api/external/7.0/sdrive.Management.create_sdrive_user"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def del_sdrive_invites(self, invite_ids, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['invite_ids'] = invite_ids
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.del_sdrive_invites"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['deleted']

    def del_sdrive_invites_async(self, invite_ids, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['invite_ids'] = invite_ids
        url = "api/external/7.0/sdrive.Management.del_sdrive_invites"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def disassociate(self, user_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.disassociate"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def disassociate_async(self, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        url = "api/external/7.0/sdrive.Management.disassociate"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_device_certificate(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_device_certificate"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['certificate']

    def get_device_certificate_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/local/7.0/sdrive.Management.get_device_certificate"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_device_private_key(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_device_private_key"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['private_key']

    def get_device_private_key_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/local/7.0/sdrive.Management.get_device_private_key"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_device_wuala_id(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_device_wuala_id"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['id']

    def get_device_wuala_id_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/local/7.0/sdrive.Management.get_device_wuala_id"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_invite_status(self, sdrive_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['sdrive_id'] = sdrive_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_invite_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['status']

    def get_invite_status_async(self, sdrive_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['sdrive_id'] = sdrive_id
        url = "api/local/7.0/sdrive.Management.get_invite_status"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_my_sdrive_account(self, __client__=None, timeout=None, raw_output=False):
        """
        This function allows to get the status of an Sdrive account from its owner point of view.
        That is to say creation related informations CAN be obtained with this function.
         UNKNOWN         : Something is wrong
         NONE            : No Sdrive account
         CREATE_PENDING  : Sdrive account creation in process. Require to be confirmed
         CREATE_CONFIRMED: Account functional but require to be associated to a device be used.
         ASSOCIATED      : Sdrive account is fully functionnal. That is to say confirmed and linked to the current device.
        """
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_my_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['info']

    def get_my_sdrive_account_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.get_my_sdrive_account"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_port_for_user(self, id, wished_port, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['id'] = id
        params['wished_port'] = wished_port
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_port_for_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['actual_port']

    def get_port_for_user_async(self, id, wished_port, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['id'] = id
        params['wished_port'] = wished_port
        url = "api/local/7.0/sdrive.Management.get_port_for_user"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_remote_access(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_remote_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['enabled']

    def get_remote_access_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.get_remote_access"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_remote_status(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_remote_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['status']

    def get_remote_status_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.get_remote_status"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_sdrive_account(self, user_id, __client__=None, timeout=None, raw_output=False):
        """
        This function allows to get the status of an Sdrive account from an invite point of view.
        That is to say creation related information CANNOT be obtained with this function.
         UNKNOWN        : Something is wrong
         NONE           : The only conclusion here is that the account is neither confirmed or associated to the current device
         INVITE_PENDING : Like NONE but we also know an invite has been sent from the current device.
         ASSOCIATED     : Sdrive account is fully functionnal. That is to say confirmed and linked to the current device.
        """
        params = dict()
        params['user_id'] = user_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_sdrive_account"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['info']

    def get_sdrive_account_async(self, user_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_id'] = user_id
        url = "api/external/7.0/sdrive.Management.get_sdrive_account"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_sdrive_info(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_sdrive_info"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['info']

    def get_sdrive_info_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.get_sdrive_info"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_user_from_wuala_id(self, wuala_id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['wuala_id'] = wuala_id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.get_user_from_wuala_id"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['login_password']

    def get_user_from_wuala_id_async(self, wuala_id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['wuala_id'] = wuala_id
        url = "api/local/7.0/sdrive.Management.get_user_from_wuala_id"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_user_status(self, user_email, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['user_email'] = user_email
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_user_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['status']

    def get_user_status_async(self, user_email, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        url = "api/external/7.0/sdrive.Management.get_user_status"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_version(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.get_version"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['version']

    def get_version_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.get_version"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def invite(self, email, inviter_password, locale, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['email'] = email
        params['inviter_password'] = inviter_password
        params['locale'] = locale
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.invite"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def invite_async(self, email, inviter_password, locale, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['email'] = email
        params['inviter_password'] = inviter_password
        params['locale'] = locale
        url = "api/external/7.0/sdrive.Management.invite"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def invite_user(self, email, user_id, inviter_password, locale, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['email'] = email
        params['user_id'] = user_id
        params['inviter_password'] = inviter_password
        params['locale'] = locale
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.invite_user"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def invite_user_async(self, email, user_id, inviter_password, locale, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['email'] = email
        params['user_id'] = user_id
        params['inviter_password'] = inviter_password
        params['locale'] = locale
        url = "api/external/7.0/sdrive.Management.invite_user"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def is_id_in_associated_list(self, id, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['id'] = id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.is_id_in_associated_list"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['in_list']

    def is_id_in_associated_list_async(self, id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['id'] = id
        url = "api/local/7.0/sdrive.Management.is_id_in_associated_list"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def is_registration_done(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.is_registration_done"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['done']

    def is_registration_done_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.is_registration_done"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def list_available_configs(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.list_available_configs"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['configs']

    def list_available_configs_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.list_available_configs"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def list_sdrive_invites(self, with_parameters, list_info, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.list_sdrive_invites"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['invites']

    def list_sdrive_invites_async(self, with_parameters, list_info, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['with_parameters'] = with_parameters
        params['list_info'] = list_info
        url = "api/external/7.0/sdrive.Management.list_sdrive_invites"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def registerDevice(self, __client__=None, timeout=None, raw_output=False):
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.registerDevice"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def registerDevice_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/sdrive.Management.registerDevice"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_config(self, config, __client__=None, timeout=None, raw_output=False):
        """
        This won't return anything since the device will restart
        """
        params = dict()
        params['config'] = config
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.set_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_config_async(self, config, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['config'] = config
        url = "api/external/7.0/sdrive.Management.set_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_device_certificate_and_private_key(self, certificate, key, __client__=None, timeout=None, raw_output=False):
        """
         This can only be done once
        """
        params = dict()
        params['certificate'] = certificate
        params['key'] = key
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.set_device_certificate_and_private_key"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_device_certificate_and_private_key_async(self, certificate, key, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['certificate'] = certificate
        params['key'] = key
        url = "api/local/7.0/sdrive.Management.set_device_certificate_and_private_key"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_device_wuala_id(self, id, __client__=None, timeout=None, raw_output=False):
        """
         This can only be done once
        """
        params = dict()
        params['id'] = id
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.set_device_wuala_id"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_device_wuala_id_async(self, id, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['id'] = id
        url = "api/local/7.0/sdrive.Management.set_device_wuala_id"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_remote_access(self, enabled, __client__=None, timeout=None, raw_output=False):
        """
         enable or disable remote access
        """
        params = dict()
        params['enabled'] = enabled
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.set_remote_access"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_remote_access_async(self, enabled, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['enabled'] = enabled
        url = "api/external/7.0/sdrive.Management.set_remote_access"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_remote_status(self, status, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['status'] = status
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/local/7.0/sdrive.Management.set_remote_status"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def set_remote_status_async(self, status, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['status'] = status
        url = "api/local/7.0/sdrive.Management.set_remote_status"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def set_welcome_done(self, async_client_ref, sdrive_user, sdrive_password, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.set_welcome_done"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['async_job_id']


    def set_welcome_done_result(self, async_job_id,__client__=None, raw_output=False, timeout=None):
        params = dict()
        params['async_job_id'] = async_job_id

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__

        url = "api/external/7.0/sdrive.Management.set_welcome_done_result"
        context = ClientTransportSender.get_context('unicorn_api')
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 



    def set_welcome_done_wait(self, async_client_ref, sdrive_user, sdrive_password, __client__=None, timeout=None, raw_output=False, nb_timeout=None, sleep=None, nb_poll=None):
        params = dict()
        params['async_client_ref'] = async_client_ref
        params['sdrive_user'] = sdrive_user
        params['sdrive_password'] = sdrive_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.set_welcome_done"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        async_job_id = res['async_job_id']
        res = ClientTransportSender.get_job_status(async_job_id)
        nbPoll = nb_poll if nb_poll is not None else 200
        nbTimeout = nb_timeout if nb_timeout is not None else 4
        sleepTime = sleep if sleep is not None else 3
        currentPoll = currentTimeout = 0
        while 2 == res.status and currentPoll < nbPoll:
            time.sleep(sleepTime)
            try:
                res = ClientTransportSender.get_job_status(async_job_id)
            except HTTPError, exc:
                if exc.status == "Timeout":
                    currentTimeout += 1
                    if currentTimeout >= nbTimeout:
                        raise
                    continue
            currentPoll += 1
        if 2 != res.status:
            return self.set_welcome_done_result(async_job_id, raw_output=raw_output)
        raise Exception('Failed to get result')


    def update_credentials(self, old_password, new_password, new_locale, new_hint, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['old_password'] = old_password
        params['new_password'] = new_password
        params['new_locale'] = new_locale
        params['new_hint'] = new_hint
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.update_credentials"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return 

    def update_credentials_async(self, old_password, new_password, new_locale, new_hint, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['old_password'] = old_password
        params['new_password'] = new_password
        params['new_locale'] = new_locale
        params['new_hint'] = new_hint
        url = "api/external/7.0/sdrive.Management.update_credentials"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def user_valid(self, user_email, user_password, __client__=None, timeout=None, raw_output=False):
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/sdrive.Management.user_valid"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['is_valid']

    def user_valid_async(self, user_email, user_password, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['user_email'] = user_email
        params['user_password'] = user_password
        url = "api/external/7.0/sdrive.Management.user_valid"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
