#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional
from unicorn_api.v7.sv0.url_proxy.UrlProxySystemInfo import UrlProxySystemInfo

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class UrlProxyAdministration(APIService):


    def get_product_image(self, nas_host, nas_port, filename, software_version, __client__=None, timeout=None, raw_output=False):
        """
         return the http response wich include the base64 image
        """
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        params['filename'] = filename
        params['software_version'] = software_version
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_product_image"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['http_base64_img']

    def get_product_image_async(self, nas_host, nas_port, filename, software_version, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        params['filename'] = filename
        params['software_version'] = software_version
        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_product_image"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_system_info(self, nas_host, nas_port, __client__=None, timeout=None, raw_output=False):
        """
         return the http response wich include system_info in xml
        """
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_system_info"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['system_info']

    def get_system_info_async(self, nas_host, nas_port, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_system_info"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def get_xml_system_info(self, nas_host, nas_port, __client__=None, timeout=None, raw_output=False):
        """
         return the http response wich include system_info in xml
        """
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_xml_system_info"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['http_xml_system_info']

    def get_xml_system_info_async(self, nas_host, nas_port, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['nas_host'] = nas_host
        params['nas_port'] = nas_port
        url = "api/external/7.0/url_proxy.UrlProxyAdministration.get_xml_system_info"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
