#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional, Instantiator, register_instantiator
from transformer.lib.proxy_class import Instantiable
from transformer.lib.cli import ClientObject
from unicorn_api.v7.sv0.url_proxy.UrlProxyRaidInfo import UrlProxyRaidInfo
from unicorn_api.v7.sv0.url_proxy.UrlProxyServiceInfo import UrlProxyServiceInfo

from transformer.lib import List


class UrlProxySystemInfoInstantiator(Instantiator):
    version = 7
    sub_version = 0
    attributes = {
        'hardware_id': unicode,
        'netbackup': Optional(bool),
        'product_id': unicode,
        'product_name': unicode,
        'puid': unicode,
        'raid_arrays': Optional(List(UrlProxyRaidInfo)),
        'services': List(UrlProxyServiceInfo),
        'soft_version': unicode,
        'welcome_xp_done': bool,
    }
    w_attributes = ["welcome_xp_done"]
    r_attributes = ["hardware_id", "netbackup", "product_id", "product_name", "puid", "raid_arrays", "services", "soft_version", "welcome_xp_done"]
    h_attributes = []
    op_values = {'netbackup': None, 'raid_arrays': None}

    @classmethod
    def name(cls):
        return u'UrlProxySystemInfo'

    @classmethod
    def new_object(cls):
        return UrlProxySystemInfo()


class UrlProxySystemInfo(ClientObject):

    def setwelcome_xp_done(self, value):
        self.welcome_xp_done = value

    def gethardware_id(self):
        return self.hardware_id

    def getnetbackup(self):
        return self.netbackup

    def getproduct_id(self):
        return self.product_id

    def getproduct_name(self):
        return self.product_name

    def getpuid(self):
        return self.puid

    def getraid_arrays(self):
        return self.raid_arrays

    def getservices(self):
        return self.services

    def getsoft_version(self):
        return self.soft_version

    def getwelcome_xp_done(self):
        return self.welcome_xp_done
    __instantiator__ = UrlProxySystemInfoInstantiator
register_instantiator('unicorn_api', UrlProxySystemInfoInstantiator, True)
