#!/usr/bin/python
# -*- coding: utf-8 -*-

#                         LACIE CONFIDENTIAL
#
# The information contained in this file is the property of LACIE.
# The user of this file shall keep information contained herein confidential
# and shall protect it in whole or in part from disclosure and dissemination
# to third parties.
# Without prior written consent of LACIE, you may not reproduce, represent,
# or download through any means, the information contained herein in any way
# or in any form for a purpose other that the use for internal evaluation,
# operation or maintenance within LACIE.
#
#          (c) LACIE, 2009 - 2012, All Rights Reserved.

#GEN_DATE Jan 18 2016 15:24:02
#
# 888b. .d88b.    8b  8 .d88b. 88888    8888 888b. 888 88888
# 8   8 8P  Y8    8Ybm8 8P  Y8   8      8www 8   8  8    8
# 8   8 8b  d8    8  '8 8b  d8   8      8    8   8  8    8
# 888P' `Y88P'    8   8 `Y88P'   8      8888 888P' 888   8
#
#

import time
from transformer.lib import Optional

from transformer.client_serializer import ClientSerializer
from transformer.lib.client import APIService


class WebDemoAdministration(APIService):


    def create_config(self, file_path, __client__=None, timeout=None, raw_output=False):
        """
         if file_path is empty "",
         write in default path (/etc/configs/current_config/unicorn/web_demo.csv)
        """
        params = dict()
        params['file_path'] = file_path
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/web_demo.WebDemoAdministration.create_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['file_path']

    def create_config_async(self, file_path, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_path'] = file_path
        url = "api/external/7.0/web_demo.WebDemoAdministration.create_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def enabled(self, restart_unicorn, __client__=None, timeout=None, raw_output=False):
        """
         enable demo mode
         if restart_unicorn is true, restart unicorn( it is mandatory
         aftewards )
        """
        params = dict()
        params['restart_unicorn'] = restart_unicorn
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/web_demo.WebDemoAdministration.enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['enabled']

    def enabled_async(self, restart_unicorn, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['restart_unicorn'] = restart_unicorn
        url = "api/external/7.0/web_demo.WebDemoAdministration.enabled"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def is_enabled(self, __client__=None, timeout=None, raw_output=False):
        """
         check if demo mode is on
        """
        params = dict()

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/web_demo.WebDemoAdministration.is_enabled"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['enabled']

    def is_enabled_async(self, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()

        url = "api/external/7.0/web_demo.WebDemoAdministration.is_enabled"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)


    def update_config(self, file_path, __client__=None, timeout=None, raw_output=False):
        """
         if file_path is empty "",
         write in default path (/etc/configs/current_config/unicorn/web_demo.csv)
        """
        params = dict()
        params['file_path'] = file_path
        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = self.__client__
        context = ClientTransportSender.get_context('unicorn_api')

        url = "api/external/7.0/web_demo.WebDemoAdministration.update_config"
        success, resp = ClientTransportSender.send(url,ClientSerializer.to_string(context, params))
        if raw_output:
            return success, resp
        res = ClientSerializer.from_string(context, success, resp)
        return res['file_path']

    def update_config_async(self, file_path, callback, __client__=None):

        if __client__:
            ClientTransportSender = __client__
        else:
            ClientTransportSender = ClientTransport
        params = dict()
        params['file_path'] = file_path
        url = "api/external/7.0/web_demo.WebDemoAdministration.update_config"
        context = ClientTransportSender.get_context('unicorn_api')
        ClientTransportSender.async(url, ClientSerializer.to_string(context, params), callback, context)
